%{
(* --- prambule: ici du code Caml --- *)

open Expr   (* rappel: dans expr.ml: 
             type expr = Const of int | Add of expr*expr | Mull of expr*expr *)

%}
/* description des lexmes, ceux-ci sont dcrits (par vous) dans lexer.mll */

%token <int> INT       /* le lexme INT a un attribut entier */
%token PLUS TIMES 
%token LPAREN RPAREN
%token EOL             /* retour  la ligne */


%left PLUS   /* associativit gauche: a+b+c, c'est (a+b)+c */
%left TIMES



%start main             /* "start" signale le point d'entre: */
                        /* c'est ici main, qui est dfini plus bas */
%type <Expr.expr> main     /* on _doit_ donner le type associ  main, qui est le point d'entre */

%%
    /* --- dbut des rgles de grammaire --- */
                            /*  droite, les valeurs associes */


main:                       /* <- le point d'entre (cf. + haut, "start") */
    expression EOL                { $1 }  /* on veut reconnatre une "expression" */
;
expression:			    /* rgles de grammaire pour les expressions */
  | INT                                { Const $1 }
  | LPAREN expression RPAREN           { $2 } /* on rcupre le deuxime lment */
  | expression PLUS expression          { Add($1,$3) }
  | expression TIMES expression         { Mul($1,$3) }
;

